# ===============================================
# (C) 2018 AO Kaspersky Lab. All Rights Reserved.
# ===============================================
import logging
from dt_classifier_common import Detect, RuleState, wait_detect_silent
import dt_Options as Options
import hashlib
from datetime import datetime

class AbstractFactor(object):

    def get_name(self):
        raise NotImplementedError("Abstract rule");

    def get_version(self):
        raise NotImplementedError("Abstract rule");

    def calculate(self, data):
        """Evaluating current computer"""
        raise NotImplementedError("Abstract rule");


class AbstractSimpleFactor(AbstractFactor):

    def __init__(self, name, version, factor_function):
        self.factor_function = factor_function
        self.name = name
        self.version = version
        return super(AbstractFactor, self).__init__()

    def get_name(self):
        return self.name

    def get_version(self):
        return self.version

    def calculate(self, data):
        return self.factor_function(data)


FACTORS = []
